#include <bits/stdc++.h>;

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int N;
    cin >> N;
    int zalihe[4]; //O A B AB
    cin >> zalihe[0] >> zalihe[1] >> zalihe[2] >> zalihe[3];
    int izlaz [N][4] = {0};
    pair <string, int> pacijenti[N];
    int potraznja[4] = {0}; //O A B AB
    for(int i = 0; i < N; i++)
    {
        cin >> pacijenti[i].first >> pacijenti[i].second;
    }
    cout << "nemoguce";


    return 0;
}